#include "Employee.h"

Employee::Employee(int id, std::string name, double salary) : id_(id), name_(name), salary_(salary) 
{
    /* empty */
}

const int Employee::getId() const
{ 
    return id_; 
}

const std::string Employee::getName() const
{ 
    return name_; 
}

const double Employee::getSalary() const
{ 
    return salary_; 
}

const std::string Employee::toString() const
{
    return 
        std::to_string(id_) + "\t" +
        name_ + "\t" +
        std::to_string(salary_);

}
