
#include <iostream>     // std::cout
#include <fstream>      // std::fstream 
#include <algorithm>    // std::sort
#include <vector>       // std::vector

#include "Employee.h"

using namespace std;

// This is a functor for comparing Employee references. A functor
// is simply a class or struct that defines an operator(), which 
// means that they can be called in a similar style to how you would
// call a function.
struct byEmployeeId {
  bool operator()( const Employee& lhs, const Employee& rhs ) const { 
      // TODO (5): Change this so that it works for Employees
      return false;
  }
};

// This main function is where the program starts. The function main takes 
// two arguments, argc and argv. The second, argv (argument vector) is an
// array of pointers to chars. The first, argc (argument count) is the length
// of the argv array. argv[0] is the name of the executable. 
int main(int argc, char *argv[])
{
  int id;
  std::string name;
  double salary;
  int size;
  char* text;
  std::vector<Employee> employees;
  char * in;
  char * out;

  // Check the command line arguments to see if they've been passed correctly.
  if (argc != 3) {
      std::cerr << "employee-sort <in> <out>" << std::endl;
      std::cerr << "Example: employee-sort input/test.bin ./output.bin" << std::endl;
      exit(1);
  }

  in  = argv[1];
  out = argv[2];

  // TODO (1): Open the input file to read in binary format

  // TODO (2) : In a loop, read records until the end of the file. For each
  // record, read the id, size of name, name, and the salary.
  // Then create an Employee object with that data, and push_back
  // the object into the vector of employees.

  // TODO: (3) Close the input file

  // TODO: (4) Sort the vector of employees. You may use std:sort, and
  // you might want to use the byEmployeeId functor above.

  // TODO: (6) Open the output file to write in binary format

  // For each employee in the vector, write the
  // the id, size of name, name, and the salary.
  for (Employee e : employees) {
      // TODO (7) : write the employee data to the output file
      // TODO (8) : write the employee data to std::out
  }

  // TODO (9): Close the output file
 
  return 0;
}


